unit Unit1;

{
 sudoku analyser
 event handlers, paint procedures
 see game_unit for game procedures
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, shellApi;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    clearBtn: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    GObtn: TSpeedButton;
    msglabel: TLabel;
    SpeedButton8: TSpeedButton;
    optionbox: TCheckBox;
    orgBtn: TSpeedButton;
    solveBtn: TSpeedButton;
    userBtn: TSpeedButton;
    davdata: TImage;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    openBtn: TButton;
    saveBtn: TButton;
    helpBtn: TButton;
    exitBtn: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    recalcbutton: TSpeedButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure FormPaint(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure GObtnClick(Sender: TObject);
    procedure clearBtnClick(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure optionboxClick(Sender: TObject);
    procedure solveBtnClick(Sender: TObject);
    procedure orgBtnClick(Sender: TObject);
    procedure userBtnClick(Sender: TObject);
    procedure openBtnClick(Sender: TObject);
    procedure saveBtnClick(Sender: TObject);
    procedure helpBtnClick(Sender: TObject);
    procedure exitBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure davdataClick(Sender: TObject);
    procedure recalcbuttonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure Pause;
procedure repaintfield(fld : byte);
procedure paintoptionmark(fld,opt : byte; color : dword);
procedure crossOption(f,n:byte);
procedure repaintgame;
procedure paintRedNr(f,n : byte);
procedure paintCursor(fld : byte; c : dword);

var
  Form1: TForm1;
  ExitFlag : boolean; //fall through
  StopFlag : boolean; //wait to clear

implementation

{$R *.dfm}

uses game_unit,io_unit;

type Tmenubutton = (mbOff,mbNew,mbPlay,mbAnalyse);

const xx : array[1..9] of byte = ( 8,24,40, 8,24,40, 8,24,40); //option positions
      yy : array[1..9] of byte = ( 5, 5, 5,22,22,22,40,40,40);
      cursorColor = $00a0ff;
      leader = 'Sudoku-Kraker : ';

var OptNr    : byte;   //...     ...:...    option 1..9
    OptField : byte;   //1..9 column of optionfield
    cursorField : byte;
//
    menubutton  : Tmenubutton = mbOff;
    solveresult : TSolveResult = srNone;
    solveNr     : word;

procedure Pause;
//set stopflag, wait to clear
//exit on exitflag
begin
 StopFlag := true;
 repeat
  application.processmessages;
 until Exitflag or (StopFlag = false);
 stopflag := false;
end;

function Busy : boolean;
//call to end old threads
begin
 if stopflag then
  begin
   result := true;
   form1.msglabel.Caption := 'analyse bezig, druk STOP';
  end
  else result := false;
end;

procedure lockmenu;
//fix analyse mode
begin
 with form1 do
  begin
   speedbutton8.Enabled := false;
   speedbutton4.Enabled := false;
  end;
end;

procedure unlockmenu;
//enable all menu buttons
begin
  with form1 do
  begin
   speedbutton8.Enabled := true;
   speedbutton4.Enabled := true;
  end;
end;

//-- paint helpers --

function getFieldRect(fld : byte) : TRect;
//supplyrectangle of field (x,y)
var col,row : byte;
begin
 field2CR(col,row,fld);
 with result do
  begin
   dec(col);
   dec(row);
   left := col * 65+2;
   top := row * 65+2;
   right := col * 65 + 63;
   bottom := row * 65 + 63;
  end;
end;

function XY2Field(x,y : smallInt) : byte;
//OK
//convert (x,y) to column cc, row rr
//return 0 if not in field
var mx,my,col,row : byte;
begin
 if x < 0 then x := 0;
 if y < 0 then y := 0;
 mx := x mod 65;
 my := y mod 65;
 if (mx>4) and (mx<61) and (my>4) and (my<61) then
  begin
   col := (x div 65) + 1;
   row := (y div 65) + 1;
   result := CR2field(col,row);
  end
  else result := 0;
end;

procedure paintOptionMark(fld,opt : byte; color : dword);
//paint marker in field fld for option 1..9
//white color clears marker
var r : Trect;
    x,y : smallInt;
begin
 r := getFieldRect(fld);
 x := r.Left + xx[opt]-2;
 y := r.Top + yy[opt];
 with form1.PaintBox1.Canvas do
  begin
   pen.Create.Width := 1;
   pen.Color := color;
   brush.Style := bsClear;
   rectangle(x,y,x+12,y+16);
  end;
end;

procedure crossOption(f,n : byte);
//red square and X cross through option n of field f
var r : Trect;
    x,y : smallInt;
begin
 r := getFieldRect(f);
 x := r.Left + xx[n];
 y := r.Top + yy[n];
 with form1.PaintBox1.Canvas do
  begin
   pen.Color := $4040ff;
   pen.Width := 1;
   moveto(x-2,y);
   lineto(x+10,y+16);
   moveto(x-2,y+15);
   lineto(x+10,y-1);
  end;
 paintoptionmark(f,n,$ff);
end;

procedure procOptionfield(x,y : smallInt);
//called when mouse moves over fieldoptions during new,play mode
//set optfield and optNr; 0:none
var cc,rr,fld,opt,n : byte;
    w,mask : word;
    hit : boolean;
    r : Trect;
begin
 opt := 0; n := 0; w := 0;
 hit := false;
 fld := XY2Field(x,y);
 if form1.optionbox.Checked = false then
  begin
   optField := fld;
   exit;
  end; 
//
 if fld > 0 then
  begin
   field2CR(cc,rr,fld);
   w := game[cc,rr].options;
   n := 0;
   r := getFieldRect(fld);
   repeat
    inc(n);
    hit := (x>r.Left+xx[n]) and (x<r.left+xx[n]+10) and
           (y>r.Top+yy[n] ) and (y<r.Top + yy[n]+16);
   until hit or (n=9);
  end;//if fld
 if hit then
  begin
   mask := 1 shl n;
   hit := hit and (game[cc,rr].mt=mtFree) and ((mask and w) > 0);
   if hit then opt := n else opt := 0;
  end;
//
 if (fld <> optfield) or (opt <> optNr) then    //if change
  if optNr > 0 then paintOptionmark(optField,optNr,$ffffff); //clear
 if hit then paintoptionmark(fld,opt,$0000ff); //red rectangle
 optNr := opt;
 optField := fld;
end;

procedure paintCursor(fld : byte; c : dword);
//paint marker area in field, white to erase
var r : Trect;
    x1,y1,x2,y2 : word;
    i : byte;
begin
 r := getFieldRect(fld);
 with form1.PaintBox1.Canvas do
  begin
   pen.Color := c;
   pen.Width := 1;
   x1 := r.Left;
   y1 := r.Top;
   x2 := r.Right-1;
   y2 := r.Bottom-1;
   for i := 0 to 2 do
    begin
     moveto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
     lineto(x1+i,y1+i);
    end;
  end;
end;

procedure setCursor(fld : byte);
//n=0:erase
begin
 if (cursorfield <> fld) then
  begin
   if (cursorfield > 0) then paintCursor(cursorfield,$ffffff);
   Cursorfield := fld;
   if Cursorfield > 0 then paintCursor(Cursorfield,cursorcolor);
  end;
end;

procedure paintRedNr(f,n : byte);
//paint big red nr for deleted options (used by zero field detection)
var r : Trect;
begin
 r := getFieldRect(f);
 with form1.paintbox1.canvas do
  begin
   font.name := 'arial';
   font.style := [];
   font.height := 48;
   font.Color := $0000ff;
   textout(r.left,r.top,inttostr(n));
  end; 
end;

procedure paintfieldBG(fld : byte; c : dword);
//set background color of field n to color c
var r : Trect;
begin
 r := getFieldRect(fld);
 with form1.PaintBox1 do with canvas do
  begin
   brush.Color := c;
   brush.Style := bsSolid;
   fillrect(r);
  end;
end;

procedure paintfield(fld : byte);
//write field fld on background
var n,col,row : byte;
    w,x,y : word;
    r : Trect;
begin
 field2CR(col,row,fld);
 r := getfieldrect(fld);
 with form1.PaintBox1.Canvas do
  begin
   font.Name := 'arial';
   font.Style := [];
   font.Height := 48;
   brush.Style := bsClear;
   with game[col,row] do
    begin
     if move > 0 then
      begin
       case mt of
        mtOrg   : font.Color := $000080;
        mtPlay  : font.Color := $0;
        mtFree  : font.color := $ff00ff;
       end;
       textout(r.Left+20,r.Top+10,inttostr(move));
      end //if move
      else
       if form1.optionbox.checked then
        begin
         font.Height := 18;
         font.Color := $808080;
         w := options;
         for n := 1 to 9 do
          if (1 shl n) and w > 0 then
           begin
            x := r.Left+ xx[n];
            y := r.Top + yy[n];
            textout(x,y,inttostr(n));
           end;
        end; //if optiombox
    end;//with game
  end;//with form1
 if (menubutton=mbNew) or (menubutton=mbPlay) then
  if (fld = cursorfield) then paintCursor(fld,cursorcolor);
end;

procedure repaintfield(fld : byte);
//paint background + contents
begin
 paintfieldBG(fld,$ffffff);
 paintfield(fld);
end;

procedure repaintgame;
var i : byte;
begin
 for i := 1 to 81 do repaintField(i);
end;

procedure paintframe;
//in paintbox1
var i : word;
begin
 with form1.PaintBox1 do with canvas do
  begin
   brush.Color := $ffffff;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
   i := 65;
   pen.color := $000000;
   pen.Width := 1;
   while i < width do
    begin
     moveto(i,0);
     lineto(i,height);
     moveto(0,i);
     lineto(width,i);
     inc(i,65);
    end;
   i:= 195;
   pen.Width := 3;
   while i < width do
    begin
     moveto(i,0);
     lineto(i,height);
     moveto(0,i,);
     lineto(width,i);
     inc(i,195);
    end;
  end;
end;

procedure initgame;
//reset all , do not paint
var i,j : byte;
begin
 for i := 1 to 9 do
  for j := 1 to 9 do
   with game[i,j] do
    begin
     mt := mtFree;
     move := 0;
     options := $3fe;
   end;
 cursorfield := 0;
 OptNr := 0;
 optfield := 0;
 solveResult := srNone;
end;

procedure movecursor;
//to next field
var m : byte;
begin
 if (cursorfield > 0) then
  begin
   m := cursorfield + 1;
   if m > 81 then m := 1;
   setCursor(m);
  end;
end;

function checkSolution : boolean;
//return true if all numbers filled in (during play mode)
var i,j,sum : byte;
begin
 sum := 0;
 for j := 1 to 9 do
  for i := 1 to 9 do if game[i,j].move > 0 then inc(sum);
 result := sum = 81;
end;

procedure procDelete;
//delete pressed during new or play
//restore options in col,row,group if number deleted
var b,col,row : byte;
begin
 field2CR(col,row,cursorfield);
 if (menubutton=mbNew) or
   ((menubutton=mbPlay) and (game[col,row].mt = mtPlay)) then
  if cursorfield > 0 then
   with game[col,row] do
    begin
     b := move;
     if b > 0 then
      begin
       move := 0;
       mt := mtFree;
       recalcOptions;
       repaintgame;
      end;
    end;//with
 if menubutton = mbPlay then
  form1.msglabel.Caption := 'volgende zet...';
end;

procedure procNumber(fld,Nr : byte);
//called to enter a new number
var col,row : byte;
    mask : word;
begin
 field2CR(col,row,fld);
 mask := 1 shl Nr;
 with game[col,row] do
  begin
   move := Nr;
   case menubutton of
    mbNew : mt := mtOrg;
    mbPlay : mt := mtPlay;
   end;//case
   dropCRGoption(fld,mask);
   options := mask;
  end;
 repaintgame;
 if menubutton = mbPlay then
  if checkSolution then form1.msglabel.Caption := 'game solved'
   else form1.msglabel.Caption := 'volgende zet...';
end;

procedure restoreOption(fld,nr : byte);
//restore option nr in field fld
var cc,rr : byte;
begin
 field2CR(cc,rr,fld);
 with game[cc,rr] do options := options or (1 shl nr);
 repaintfield(fld);
end;

procedure dropfieldOption(fld, optNr : byte);
//drop option in a field during play
var col,row : byte;
    mask : word;
begin
 field2CR(col,row,fld);
 if popcount(game[col,row].options) > 1 then
  begin
    mask := (1 shl optNr) xor $3fe;
    game[col,row].options := game[col,row].options and mask;
    repaintfield(fld);
   end;
end;

//-- events --

procedure TForm1.FormPaint(Sender: TObject);
//paint edge around paintbox1
//write numbers of columns,rows
var x1,y1,x2,y2 : word;
    i : byte;
begin
 with paintbox1 do
  begin
   x1 := left-2;
   y1 := top-2;
   x2 := left+width+1;
   y2 := top +height+1;
  end;
 with canvas do
  begin
   pen.Width := 1;
   for i := 0 to 1 do
    begin
     pen.Color := $000000;
     moveto(x2-i,y1+i);
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     pen.Color := $808080;
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
    end;
   font.Name := 'arial';
   font.height := 16;
   font.Color := $000000;
   font.Style := [];
   brush.Style := bsClear;
   for i := 1 to 9 do
    begin
     textout(10,35+65*i,inttostr(i));
     textout(65*i-5,50,inttostr(i));
    end;
  end;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 paintframe;
 repaintgame;
end;

procedure TForm1.clearBtnClick(Sender: TObject);
begin
 if busy then exit;

 initgame;
 repaintgame;
 setcursor(0);
 if (menubutton = mbPlay) or (menubutton=mbNew) then setcursor(1);
 solveresult := srNone;
 msglabel.Caption := '';
 caption := leader;
end;

procedure TForm1.SpeedButton1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
//common for all menubuttons
var bnr : byte;
begin
 if busy then exit;

 msglabel.Caption := '';
 case menubutton of  //closing actions
  mbNew     : ;
  mbPlay    : ;
  mbAnalyse : exitflag := true;
 end;
//
 menubutton := mbOff;
 bnr := TSpeedbutton(sender).Tag;
 menubutton := TMenubutton(bnr);
  case menubutton of
   mbNew     : begin
                setCursor(1);
                msglabel.Caption := 'nieuw spel invoeren';
               end;
   mbPlay    : msglabel.Caption := 'nieuwe zet...';
   mbAnalyse : begin
                setcursor(0);
                msglabel.Caption := 'druk GO voor analyse';
               end;
  end;//case
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var col,row : byte;
begin
 if optfield = 0 then exit;
//
 if (optNr = 0) then
  if (menubutton=mbNew) or (menubutton=mbPlay) then
   begin
    setcursor(optfield);
    paintcursor(OptField,cursorcolor);
    exit;
   end;
//
 field2CR(col,row,optfield);
 case menubutton of
  mbNew  : begin
            procNumber(optfield,OptNr);
            setcursor(optField);
            movecursor;
           end; 
  mbPlay : if button = mbRight then
            begin
             if popcount(game[col,row].options) > 1 then
              dropfieldOption(optField,optNr);
             setcursor(optField);
            end
            else begin
                  procNumber(optField,optNr);
                  setcursor(optField);
                  moveCursor;
                 end; 
 end;//case
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 if (menubutton=mbNew) or (menubutton=mbPlay) then procOptionField(x,y);
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
//==
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var m : byte;
begin
 if (menubutton = mbAnalyse ) then
  case key of
   VK_SPACE : stopflag := false;
  end;

 if (menubutton=mbNew) or (menubutton=mbPlay) then
  begin
   m := cursorfield;
   case key of
    VK_RIGHT,
    VK_SPACE : begin
                inc(m);
                if m > 81 then m := 1;
               end;
    VK_LEFT,
    VK_BACK  : begin
                if m <= 1 then m := 81 else dec(m);
               end;
    VK_Down  : begin
                inc(m,9);
                if m > 81 then m := m-81;
               end;
    VK_UP    : begin
                if m < 10 then m := m + 72 else dec(m,9);
               end;
    VK_DELETE : procDelete;
   end;//case
   setCursor(m);
  end;//if
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
var knr : byte;
    mask : word;
    col,row : byte;
begin
 if cursorfield > 0 then
  if key in ['1'..'9'] then
   begin
    knr := ord(key) - ord('0');
    mask := 1 shl knr;
    field2CR(col,row,cursorfield);
    with game[col,row] do
     if (mt = mtFree) then
      if (options and mask) > 0 then
       begin
        if (menubutton=mbNew) or (menubutton=mbPlay) then
         begin
          procNumber(cursorfield,knr);
          movecursor;
         end;
       end
       else
        if (menubutton = mbPlay) and optionbox.Checked then
          restoreOption(cursorField,knr);
  end;//if key
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 activecontrol := nil;
 initgame;
 msglabel.Caption := 'welkom bij de '+leader;
 if loadfromP1 then
  begin
   recalcoptions;
   caption := leader+iomessage;
  end 
  else caption := leader;
end;

procedure TForm1.optionboxClick(Sender: TObject);
begin
 activecontrol := nil;
 repaintgame;
end;

procedure TForm1.solveBtnClick(Sender: TObject);
begin
 if menubutton <> mbAnalyse then
  begin
   msglabel.Caption := 'analyse niet geselecteerd';
   exit;
  end;
//
 if busy then exit;

 if menubutton = mbAnalyse then
  begin
   if solveResult = srNone then solveNr := 0;
   solveresult := SolveBruteForce(solveresult);
   case solveresult of
    srSolution : begin
                  inc(solveNr);
                  msglabel.Caption := 'solution  ' + inttostr(solveNr);
                 end;
    srNoSolution : msglabel.Caption := 'geen oplossing';
   end;//case
   repaintgame;
  end; 
end;

procedure TForm1.orgBtnClick(Sender: TObject);
var i,j : byte;
begin
 if busy then exit;

 for i := 1 to 9 do
  for j := 1 to 9 do
   with game[i,j] do
    if (mt = mtPlay) or (mt=mtFree) then
     begin
      mt := mtFree;
      move := 0;
     end;
 recalcoptions;
 repaintgame;
 solveresult := srNone;
 msglabel.Caption := '';
end;

procedure TForm1.userBtnClick(Sender: TObject);
//restore game to user state after solving by Brute Force
var i, j : byte;
begin
 if busy then exit;

 for i := 1 to 9 do
  for j := 1 to 9 do
   with game[i,j] do if mt = mtFree then Move := 0;
 repaintgame;
 solveresult := srNone;
 msglabel.Caption := '';
end;

procedure TForm1.openBtnClick(Sender: TObject);
var code : byte;
begin
 activecontrol := nil;
 if busy then exit;

 form1.msglabel.Caption := '';
 OpenGame(code);
 case code of
  1 : begin
       form1.msglabel.caption := 'geopend : '+iomessage;
       caption := leader+iomessage;
      end;
  2 : begin
       form1.msglabel.Caption := 'leesfout';
       caption := leader;
      end;

 end;
 recalcoptions;
 repaintgame;
end;

procedure TForm1.saveBtnClick(Sender: TObject);
var code : byte;
begin
 activecontrol := nil;
 if busy then exit;

 form1.msglabel.Caption := '';
 SaveGame(code);
 case code of
  1 : begin
       form1.msglabel.Caption := 'opgeslagen : '+iomessage;
       caption := leader+iomessage;
      end;
  2 : form1.msglabel.Caption := 'opslaan mislukt';
 end;//case
end;

procedure TForm1.helpBtnClick(Sender: TObject);
begin
 activecontrol := nil;
 if busy then exit;

 ShellExecute(0,'open','http://www.davdata.nl/sudoku-oplosser.html', nil, nil, SW_SHOWNORMAL);
end;

procedure TForm1.exitBtnClick(Sender: TObject);
begin
 exitflag := true;
 stopflag := false;
 application.ProcessMessages;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 exitflag := true;
end;

procedure TForm1.GObtnClick(Sender: TObject);
//test  code
begin
 if menubutton = mbAnalyse then
  begin
   if optionbox.Checked = false then
    begin
     optionbox.Checked := true;
     repaintgame;
     msglabel.caption := 'druk GO voor volgende';
     exit;
    end;

   exitflag := false;
   if stopflag then
    begin
     stopflag := false;
     exit;
    end;

   lockMenu;
   setcursor(0);
   analyseGame;
   msglabel.Caption := 'einde analyse';
   unlockmenu;
  end
  else msglabel.caption := 'analyse niet geselecteerd';
end;

procedure TForm1.davdataClick(Sender: TObject);
//website link
begin
 ShellExecute(0,'open','http://www.davdata.nl', nil, nil, SW_SHOWNORMAL);
end;

procedure TForm1.recalcbuttonClick(Sender: TObject);
begin
 if busy then exit;
 
 recalcOptions;
 repaintgame;
end;

end.
